//***************************************************************************
//
// 		Fran Rodriguez. 2010, not modify, copy or distribute the code
//					http://franchu.deviantart.com/
//
//***************************************************************************

var URL="http://weather.yahooapis.com/forecastrss?p=CODIGO&u=";
var EsNoche=false;
var bgcolor_dia = "#53BBF2";// "#28C0F2";//"#84D7FF";
var bgcolor_noche = "#666666";
var txtcolor_dia = "black";
var txtcolor_noche = "black";
var txtTiempo=""
var nMin=0;
var nAct=15;

//FUNCION INICIAL AL CARGAR DEL GADGET
function init()
{
	System.Gadget.settingsUI="settings.html";
	System.Gadget.onSettingsClosed = settingsClosed;
	System.Gadget.onDock=dockGadget;
	System.Gadget.onUndock=undockGadget;	
	
	//Si es la primera vez cargamos los valores por defecto
	if(System.Gadget.Settings.readString("first")=="")
	{
		System.Gadget.Settings.write("first","false");
		System.Gadget.Settings.writeString("codigo", defaultCode);
		System.Gadget.Settings.writeString("unidad","c");
	}
	
	loadSettings();

	if(System.Gadget.docked)
	{
		dockGadget();	
	}else{
		undockGadget();	
	}

	setInterval("actualizar()",60000);
}

//CARGAMOS LOS VALORES AL GADGET
function loadSettings()
{
	mensaje.style.overflow="hidden";
	msg(msg_info_cargandoinformacion);
	try {		
		req = new ActiveXObject("Microsoft.XMLHTTP");
		if (req) {
			var urlfinal=URL.replace("CODIGO",System.Gadget.Settings.readString("codigo"))+System.Gadget.Settings.readString("unidad");			
			req.open("GET", urlfinal, false);		
			req.send();			
			if (req.status == 200) {
				sitio.innerHTML=req.responseXML.documentElement.getElementsByTagName("yweather:location").item(0).getAttribute('city');
				sitio.title=sitio.innerHTML;
				temperatura.innerHTML=req.responseXML.documentElement.getElementsByTagName("yweather:condition").item(0).getAttribute('temp')+"<sup><span style='font-size:22pt;'></span></sup>";
				hAtardece=req.responseXML.documentElement.getElementsByTagName("yweather:astronomy").item(0).getAttribute('sunset');
				hAmanece=req.responseXML.documentElement.getElementsByTagName("yweather:astronomy").item(0).getAttribute('sunrise');

				var xAtardece = "";
				var xAmanece = "";
				var xActual = "";
				var fecha=new Date();
				//CONVERTIMOS LOS PM EN HORAS DE 24, Y LAS HORAS EN CIFRAS PARA COMPARARLAS Y SABER SI ES DE NOCHE O NO
				xAtardece = (parseInt(getHora(hAtardece))+12)+getMin(hAtardece);
				xAmanece = (parseInt(getHora(hAmanece)))+getMin(hAmanece);
				xActual = (fecha.getHours())+""+formatMin((fecha.getMinutes()));
				//SI ES DIA ...
				if (parseInt(xActual)>parseInt(xAmanece) && parseInt(xActual)<parseInt(xAtardece)) {
					EsNoche=false;
				} else {
					EsNoche=true;
				}
				//CONVERTIMOS EL TEXTO SI HACE FALTA
				//txtTiempo = req.responseXML.documentElement.getElementsByTagName("yweather:condition").item(0).getAttribute("text").toLowerCase().split("/")[0];
				txtTiempo = req.responseXML.documentElement.getElementsByTagName("yweather:condition").item(0).getAttribute("text").toLowerCase();
				switch (txtTiempo.split("/")[0]) 
				{
				case "fair" :
					dev = str_fair;
					n=iif(EsNoche,33,34)
					urlico = s(n);
					break;
					
				case "partly cloudy" :
					dev = str_partlycloudy;
					n=iif(EsNoche,29,30)
					urlico = s(n);
					break;
					
				case "tropical storm" :
					dev = str_tropicalstorm;
					urlico = s(1);
					break;
					
				case "severe thunderstorms" :
					dev = str_severethunderstorms;
					urlico = s(3);
					break;
					
				case "thunderstorms" :
					dev = str_thunderstorms;
					urlico = s(4);
					break;
					
				case "mixed rain and snow" :
					dev = str_mixedrainandsnow;
					urlico = s(5);
					break;
					
				case "mixed rain and sleet" :
					dev = str_mixedrainandsleet;
					urlico = s(6);
					break;
					
				case "mixed snow and sleet" :
					dev = str_mixedsnowandsleet;
					urlico = s(7);
					break;
					
				case "freezing drizzle" :
					dev = str_freezingdrizzle;
					urlico = s(8);
					break;
					
				case "snow" :
					dev = str_snow;
					urlico = s(16);
					break;
					
				case "hail" :				
					dev = str_hail;
					urlico = s(17);
					break;
					
				case "dust" :
					dev = str_dust;
					urlico = s(19);
					break;
					
				case "foggy" :
				case "fog" :
				case "mist" :
					dev = str_foggy;
					urlico = s(20);
					break;
					
				case "windy" :
					dev = str_windy;
					urlico = s(24);
					break;
					
				case "cold" :
					dev = str_cold;
					urlico = s(25);
					break;
					
				case "cloudy" :
					dev = str_cloudy;
					urlico = s(26);
					break;
					
				case "mostly cloudy" :
					dev = str_mostlycloudy;
					n=iif(EsNoche,27,28)
					urlico = s(n);
					break;
					
				case "clear" :
					dev = str_clear;
					urlico = s(31);
					break;
					
				case "sunny" :
					dev = str_sunny;
					urlico = s(32);
					break;
					
				case "mixed rain and hail" :
					dev = str_mixedrainandhail;
					urlico = s(35);
					break;
					
				case "hot" :
					dev = str_hot;
					urlico = s(36);
					break;
					
				case "isolated thunderstorms" :
					dev = str_isolatedthunderstorms;
					urlico = s(37);
					break;
					
				case "scattered thunderstorms" :
					dev = str_scatteredthunderstorms;
					urlico = s(38);
					break;
					
				case "scattered showers" :
					dev = str_scatteredshowers;
					urlico = s(40);
					break;
					
				case "heavy snow" :
					dev = str_heavysnow;
					urlico = s(41);
					break;
					
				case "clear" :
					dev = str_clear;
					urlico = s(31);
					break;
					
				case "rain" :
					dev = str_rain;
					urlico = s(12);
					break;
					
				case "light rain" :
				case "drizzle" :
				case "light drizzle" :
					dev = str_lightrain ;
					urlico = s(9);
					break;
					
				default :
					dev = "." + txtTiempo + "";
					urlico = s(3200);
					break;
				}
				temperatura.title=dev;
				imagen.src=urlico;
			
				/*
				INFORMACION EXTENDIDA
				Las Palmas de Gran Canaria
				Parcialmente despejado,22C
				Orto: 8:00 am, Ocaso: 19:21 pm
				Velocidad viento: 12kph
				Humedad: 50%
				*/
					infoextra.innerHTML="<strong>" + sitio.innerHTML + ", " + req.responseXML.documentElement.getElementsByTagName("yweather:condition").item(0).getAttribute('temp') + "" + req.responseXML.documentElement.getElementsByTagName("yweather:units").item(0).getAttribute('temperature') + " </strong><br>" + dev +  "<br>" + str_orto + hAmanece + "<br>" + str_ocaso + hAtardece + "<br>" + str_velocidadviento + req.responseXML.documentElement.getElementsByTagName("yweather:wind").item(0).getAttribute('speed') + " " + req.responseXML.documentElement.getElementsByTagName("yweather:units").item(0).getAttribute('speed') + "<br>" + str_humedad + req.responseXML.documentElement.getElementsByTagName("yweather:atmosphere").item(0).getAttribute('humidity') + "%";
				msg("");
			}
		}
	} catch (err) {
		mensaje.style.overflow="scroll";
		msg(req.status + "-" + msg_err_loadingsettings);
		temperatura.innerHTML="";
		sitio.innerHTML="";
		infoextra.innerHTML="";
		imagen.src="";
	}
}

//PARA TOMAR LA URL PARA EL TIEMPO
function s(numero) {
	if (EsNoche) {
		return "http://l.yimg.com/us.yimg.com/i/us/nws/weather/gr/"+numero+"n.png";
	} else {
		return "http://l.yimg.com/us.yimg.com/i/us/nws/weather/gr/"+numero+"d.png";
	}
}
//FUNCIONES PARA LA CONVERSIN DE TIEMPO
function getHora(dato) 
{
	var hora = "";
	/*for (i=0; i<dato.length; i++) {
		if (dato.substr(i, 1) == ":") {
			i = 50;
		} else {
			hora = hora+dato.substr(i, 1);
		}
	}*/
	return dato.split(":")[0];
	//return hora;
}

function formatMin(dato) {
	if (parseInt(dato)<10) {
		dato = "0" + parseInt(dato);
	}
	return dato;
}

function getMin(dato) 
{
	var m = "";
	var guardarMin = false;
	for (i=0; i<dato.length; i++) {
		if (dato.substr(i, 1) == ":") {
			guardarMin = true;
		} else if (dato.substr(i, 1) == " ") {
			i = 10;
		} else {
			if (guardarMin) {
				m = m+dato.substr(i, 1);
			}
		}
	}
	return formatMin(m);
}

// VENTANA DE CONFIGURACIN CERRADA
function settingsClosed(event)
{
    // Si el usuario ha hecho clic en OK
    if (event.closeAction == event.Action.commit)
    {	
		// Cargamos los valores del tiempo y luego actualizamos la interfaz
		loadSettings();
		if(System.Gadget.docked)
		{
			dockGadget();	
		}else{
			undockGadget();	
		}		
    }
    // Permitir que se cierre
	event.cancel = false;
}

// PERIODO DE TIEMPO EN QUE SE ACTUALIZA
function actualizar()
{
	nMin++;
	if(nMin>=nAct)
	{
		loadSettings();
		if(System.Gadget.docked)
		{
			dockGadget();	
		}else{
			undockGadget();	
		}				
		nMin=0;
	}	
}

// GADGET DOCKED - TAMAO PEQUEO
function dockGadget()
{
	System.Gadget.beginTransition();	
	
	var b = document.body.style;
	b.width="130px";
	b.height="130px";
	b.margin="0px";

	mensaje.style.position="absolute"; 
	mensaje.style.top="5px"; 
	mensaje.style.left="7px"; 
	mensaje.style.width="110px"; 
	mensaje.style.height="110px"; 
	mensaje.style.fontSize="9pt";
	mensaje.style.fontFamily="Segoe UI";	
	mensaje.style.color=iif(EsNoche,txtcolor_noche,txtcolor_dia);
	mensaje.style.zIndex="10";

	sitio.style.position="absolute"; 
	sitio.style.top="107px"; 
	sitio.style.left="9px"; 
	sitio.style.width="120px"; 
	sitio.style.height="16px"; 
	sitio.style.fontSize="8pt";
	sitio.style.fontFamily="Segoe UI";	
	sitio.style.color=iif(EsNoche,txtcolor_noche,txtcolor_dia);
	sitio.style.wordWrap="break-word";
	sitio.style.overflow="hidden";
	sitio.style.display="block";
	sitio.style.letterSpacing="0";
	sitio.style.zIndex="3";
	
	temperatura.style.position="absolute"; 
	temperatura.style.top="-8px"; 
	temperatura.style.left="0px"; 
	temperatura.style.width="130px"; 
	temperatura.style.height="130px"; 
	temperatura.style.fontSize="50pt";
	temperatura.style.fontFamily="Segoe UI Light";	
	temperatura.style.color=iif(EsNoche,txtcolor_noche,txtcolor_dia);
	temperatura.style.display="block";	
	temperatura.style.zIndex="3";	
	
	imagen_contenedor.style.position="absolute"; 
	imagen_contenedor.style.top="2px"; 
	imagen_contenedor.style.left="4px"; 
	imagen_contenedor.style.width="122px"; 
	imagen_contenedor.style.height="122px";
	imagen_contenedor.style.overflow="hidden";
	imagen_contenedor.style.zIndex="2";

	imagen.style.position="relative"; 
	imagen.style.top="-35px"; 
	imagen.style.left="-35px"; 	
	imagen.style.width="250px"; 
	imagen.style.height="180px";
	imagen.style.zIndex="5";
	imagen.style.border="1px solid transparent";

	efecto.style.position="absolute"; 
	efecto.style.top="0px"; 
	efecto.style.left="0px"; 
	efecto.style.width="130px"; 
	efecto.style.height="130px";
	efecto.style.backgroundImage="url(efecto.png)"; 
	efecto.style.zIndex="1";

	infoextra.style.position="absolute"; 
	infoextra.style.top="8px"; 
	infoextra.style.left="8px"; 
	infoextra.style.width="118px"; 
	infoextra.style.height="116px"; 
	infoextra.style.overflow="hidden";
	infoextra.style.display="none";
	infoextra.style.color=iif(EsNoche,txtcolor_noche,txtcolor_dia);	
	infoextra.style.zIndex="2";

	colorfondo.style.position="absolute"; 
	colorfondo.style.top="2px"; 
	colorfondo.style.left="4px"; 
	colorfondo.style.width="122px"; 
	colorfondo.style.height="122px"; 
	colorfondo.style.zIndex="0";
	colorfondo.style.backgroundColor=iif(EsNoche,bgcolor_noche,bgcolor_dia);


	System.Gadget.background = "fondo.png";
	
	System.Gadget.endTransition(System.Gadget.TransitionType.morph, 1);		
}

// UNDOCKED GADGET - TAMAO GRANDE
function undockGadget()
{
	System.Gadget.beginTransition();	
	
	var b = document.body.style;
	b.width="130px";
	b.height="130px";
	b.margin="0px";

	mensaje.style.position="absolute"; 
	mensaje.style.top="5px"; 
	mensaje.style.left="7px"; 
	mensaje.style.width="110px"; 
	mensaje.style.height="110px"; 
	mensaje.style.fontSize="9pt";
	mensaje.style.fontFamily="Segoe UI";	
	mensaje.style.color=iif(EsNoche,txtcolor_noche,txtcolor_dia);
	mensaje.style.zIndex="10";

	sitio.style.position="absolute"; 
	sitio.style.top="107px"; 
	sitio.style.left="9px"; 
	sitio.style.width="120px"; 
	sitio.style.height="16px"; 
	sitio.style.fontSize="8pt";
	sitio.style.fontFamily="Segoe UI";	
	sitio.style.color=iif(EsNoche,txtcolor_noche,txtcolor_dia);
	sitio.style.wordWrap="break-word";
	sitio.style.overflow="hidden";
	sitio.style.display="none";
	sitio.style.zIndex="3";
	
	temperatura.style.position="absolute"; 
	temperatura.style.top="-8px"; 
	temperatura.style.left="0px"; 
	temperatura.style.width="130px"; 
	temperatura.style.height="130px"; 
	temperatura.style.fontSize="50pt";
	temperatura.style.fontFamily="Segoe UI Light";	
	temperatura.style.color=iif(EsNoche,txtcolor_noche,txtcolor_dia);
	temperatura.style.display="none";
	temperatura.style.zIndex="3";	
	
	imagen_contenedor.style.position="absolute"; 
	imagen_contenedor.style.top="2px"; 
	imagen_contenedor.style.left="4px"; 
	imagen_contenedor.style.width="122px"; 
	imagen_contenedor.style.height="122px";
	imagen_contenedor.style.overflow="hidden";
	imagen_contenedor.style.zIndex="2";

	imagen.style.position="relative"; 
	imagen.style.top="-35px"; 
	imagen.style.left="-35px"; 	
	imagen.style.width="250px"; 
	imagen.style.height="180px";
	imagen.style.zIndex="5";
	imagen.style.border="1px solid transparent";

	efecto.style.position="absolute"; 
	efecto.style.top="0px"; 
	efecto.style.left="0px"; 
	efecto.style.width="130px"; 
	efecto.style.height="130px";
	efecto.style.backgroundImage="url(efecto.png)"; 
	efecto.style.zIndex="1";

	infoextra.style.position="absolute"; 
	infoextra.style.top="8px"; 
	infoextra.style.left="8px"; 
	infoextra.style.width="118px"; 
	infoextra.style.height="116px"; 
	infoextra.style.overflow="hidden";
	infoextra.style.display="block";
	infoextra.style.color=iif(EsNoche,txtcolor_noche,txtcolor_dia);	
	infoextra.style.zIndex="2";

	colorfondo.style.position="absolute"; 
	colorfondo.style.top="2px"; 
	colorfondo.style.left="4px"; 
	colorfondo.style.width="122px"; 
	colorfondo.style.height="122px"; 
	colorfondo.style.zIndex="0";
	colorfondo.style.backgroundColor=iif(EsNoche,bgcolor_noche,bgcolor_dia);


	System.Gadget.background = "fondo.png";
	
	System.Gadget.endTransition(System.Gadget.TransitionType.morph, 1);	}

// MOSTRAR MENSAJE
function msg(t)
{	
	mensaje.innerHTML=t+"";	
}

//IIF
function iif(condicion,verdadero,falso)
{
	if(condicion==true)
	{
		return verdadero;
	}
	else
	{
		return falso;
	}
}